diff --git a/src/eventmanager.cc b/src/eventmanager.cc
index c4cd8b1..64349e6 100644
--- a/src/eventmanager.cc
+++ b/src/eventmanager.cc
@@ -120,6 +120,8 @@ void imeventmanager::store(const imevent &cev) {
 		
 	        c->sethasevents(true);
 	        c->playsound(ev.gettype());
+                conf.execaction("kdialog", ev.getcontact().nickname);
+
 
 	        external.exec(ev);
 
diff --git a/src/icqconf.cc b/src/icqconf.cc
index 16725ed..ede5d70 100644
--- a/src/icqconf.cc
+++ b/src/icqconf.cc
@@ -885,7 +885,7 @@ void icqconf::loadactions() {
 	if(of.is_open()) {
 	    of << "# This file contains external actions configuration for centerim" << endl;
 	    of << "# Every line should look like: <action> <command>" << endl;
-	    of << "# Possible actions are: openurl, detectmusic" << endl << endl;
+	    of << "# Possible actions are: openurl, detectmusic, kdialog" << endl << endl;
 
 	    of << "openurl \\" << endl;
 	    of << "    (if test ! -z \"`ps x | grep /" << browser << " | grep -v grep`\"; \\" << endl;
@@ -898,6 +898,9 @@ void icqconf::loadactions() {
 	    of << "\tthen cat ~/.orpheus/currently_playing; \\" << endl;
 	    of << "     fi" << endl;
 
+            of << "kdialog \\" << endl;
+            of << "     DISPLAY=:0 /usr/bin/kdialog --passivepopup 'new message from $from$' 10 >/tmp/centerim 2>&" << endl;
+
 	    of.close();
 	}
     }
@@ -912,13 +915,13 @@ void icqconf::loadactions() {
 	    getstring(f, buf);
 	    if(!cont) name = getword(buf);
 
-	    if(name == "openurl" || name == "detectmusic") {
+	    /*if(name == "openurl" || name == "detectmusic") {*/
 		if(!buf.empty())
 		if(cont = buf.substr(buf.size()-1, 1) == "\\")
 		    buf.erase(buf.size()-1, 1);
 
 		actions[name] += buf;
-	    }
+	    /*}*/
 	}
 
 	f.close();
@@ -1171,6 +1174,11 @@ string icqconf::execaction(const string &name, const string &param) {
     while((npos = torun.find("$url$")) != -1)
 	torun.replace(npos, 5, param);
 
+    if(name == "kdialog") 
+    while((npos = torun.find("$from$")) != -1)
+        torun.replace(npos, 6, param);
+
+    
     if(!pipe(inpipe) && !pipe(outpipe)) {
 	memset(&sact, 0, sizeof(sact));
 	sigaction(SIGCHLD, &sact, &osact);
